package com.albertoventurini.parsley.grammar;

import com.albertoventurini.parsley.grammar.rules.Rule;

import java.util.Optional;

public abstract class Grammar {

    protected abstract Rule startRule();

    protected abstract Rule commentRule();

    protected boolean whitespace(final char c) {
        return Character.isWhitespace(c);
    }

    public Optional<ParseTree> parse(final String text) {
        final var ctx = new GrammarContext(text, commentRule(), this::whitespace);
        return startRule().apply(ctx);
    }

}
