package com.albertoventurini.parsley.grammar.rules;

import com.albertoventurini.parsley.grammar.GrammarContext;
import com.albertoventurini.parsley.grammar.ParseTree;

import java.util.Optional;

public class AnyToken extends Rule {

    public AnyToken() {
        this.name = "AnyToken";
    }

    @Override
    public Optional<ParseTree> tryApply(final GrammarContext ctx) {
        ctx.advanceToNextToken();

        if (!ctx.hasNext()) {
            return Optional.empty();
        }

        final int start = ctx.getCursor();
        ctx.advanceToEndOfToken();

        return Optional.of(ParseTree.leaf(name, ctx.substring(start)));
    }
}
